package com.yihu.quota.etl.formula;

import com.yihu.quota.service.source.DataSourcesTableFieldService;
import com.yihu.quota.vo.DataSourcesTableModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;

/**
 * 表关联
 * @author janseny
 */
@Component
public class RelevanceFunc {

    @Autowired
    private JdbcTemplate jdbcTemplate;
    @Autowired
    private DataSourcesTableFieldService dataSourcesTableFieldService;


    /**
     * 获取关联字段值
     * @param  dataFieldId  数据 对应源字段ID
     * @param relationFieldId 关联字段ID
     * @param relationFieldVal 关联字段值
     */
    public String getRelationFieldVal(String dataFieldId,String relationFieldId ,String relationFieldVal) throws Exception {
        try {
            String value = null;
            DataSourcesTableModel dtm = dataSourcesTableFieldService.findDataSourcesTableModel(dataFieldId);
            DataSourcesTableModel subDtm = dataSourcesTableFieldService.findDataSourcesTableModel(relationFieldId);
            if(dtm != null && subDtm != null){
                value = getEntityByRelationId(subDtm.getDatabaseName() ,subDtm.getTableCode(), dtm.getFieldCode(),subDtm.getFieldCode(),subDtm.getFieldType(),relationFieldVal);
            }
            return value;
        }catch (Exception e){
            throw e;
        }
    }

    /**
     *
     * @param database 数据库名
     * @param table    表名
     * @param cloumnCode 列名
     * @param relationCode 关联字段名
     * @param relationColDataType 关联字段类型
     * @param relationVal 关联字段值
     * @return
     * @throws Exception
     */
    public String getEntityByRelationId(String database ,String table, String cloumnCode ,String relationCode,String relationColDataType ,
                                        String relationVal) throws Exception {
        try {
            String sql = "";
            if(relationColDataType.toLowerCase().equals("string")){
                sql = " SELECT " + cloumnCode + " FROM " + database + "." + table + " WHERE " + relationCode + "= '" + relationVal + "' ";
            }else {
                sql = " SELECT " + cloumnCode + " FROM " + database + "." + table + " WHERE " + relationCode + "= " + relationVal;
            }
            List<Map<String, Object>> list = jdbcTemplate.queryForList(sql);
            if(list != null && list.size() > 0){
                Map<String, Object> map  = list.get(0);
                if(map.get(cloumnCode) == null ){
                    return null;
                }
                return map.get(cloumnCode).toString();
            }else {
                return null;
            }
        }catch (Exception e){
            throw new Exception(" 数据查询异常");
        }
    }
}
