package com.yihu.quota.service.cube;

import com.yihu.ehr.query.BaseJpaService;
import com.yihu.quota.dao.cube.CubeDao;
import com.yihu.quota.model.cube.Cube;
import com.yihu.quota.vo.CubeMappingModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;


/**
 * 多维数据集
 * Created by janseny on 2018/9/10.
 * @author janseny
 */
@Service
public class CubeService extends BaseJpaService<Cube, CubeDao> {

    @Autowired
    private CubeDao cubeDao;
    @Autowired
    private CubeMappingService cubeMappingService;

    /**
     * 保存接口
     * @param cube
     * @return 保存之后的id
     */
    public Integer saveOlapCube(Cube cube) {
        cube = cubeDao.save(cube);
        return cube.getId();
    }

    public void deleteOlapCube(Integer id) {
        cubeDao.delete(id);
    }

    public Cube findOne(Integer id) {
        return cubeDao.findOne(id);
    }

    /**
     * 查询维度的数据类型
     * @param cubeCode 数据集编码
     * @param dimensionCode 维度编码 如果是对象子属性，参数格式为 主维度.子属性 如 event.no
     * @return
     */
    public String findDimensionDataType(String cubeCode,String dimensionCode){
        CubeMappingModel cubeMappingModel = cubeMappingService.findCubeMappingModelByCubeAndCode(cubeCode, dimensionCode);
        if(cubeMappingModel !=null){
            return  cubeMappingModel.getDataType();
        }
        return null;
    }
}
