package com.yihu.quota.service.source;

import com.yihu.ehr.query.BaseJpaService;
import com.yihu.quota.dao.source.DataSourcesTableFieldDao;
import com.yihu.quota.model.source.DataSourcesTableField;
import com.yihu.quota.vo.DataSourcesTableModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.stereotype.Service;

import java.util.Arrays;
import java.util.List;

/**
 * Created by wxw on 2018/9/10.
 *
 * @author wxw.
 */
@Service
public class DataSourcesTableFieldService extends BaseJpaService<DataSourcesTableField, DataSourcesTableFieldDao> {

    @Autowired
    private DataSourcesTableFieldDao dataSourcesTableFieldDao;

    /**
     * 定义基础数据类型
     */
    private final static String[] TYPE = {"tiny int", "int", "integer", "float", "long", "double", "decimal", "char",
            "varchar", "text", "string", "date", "datetime", "timestamp", "time", "binary", "boolean", "nested", "keyword"};

    /**
     * 是否是允许的数据类型
     * @param fieldType
     * @return
     */
    public boolean isAllowType(String fieldType) {
        List<String> list = Arrays.asList(TYPE);
        if (list.contains(fieldType.toLowerCase())) {
            return true;
        }
        return false;
    }

    public DataSourcesTableField findById(int id){
        return dataSourcesTableFieldDao.findOne(id);
    }

    /**
     * 根据 表编码和关联字段编码 查询对应的维度信息
     * @param fieldId 关联字段
     * @return
     */
    public DataSourcesTableModel findDataSourcesTableModel(String fieldId) {
        String sql = "SELECT odstf.*,odst.table_code,odst.database_name from olap_data_sources_table_field odstf  " +
                " LEFT JOIN olap_data_sources_table odst on odst.id = odstf.table_id " +
                " WHERE odstf.id = ? ";
        String param[] = {fieldId};
        List<DataSourcesTableModel> cubeMemberMappingModels = jdbcTemplate.query(sql, new BeanPropertyRowMapper(DataSourcesTableModel.class), param);
        if(cubeMemberMappingModels != null && cubeMemberMappingModels.size() > 0){
            return  cubeMemberMappingModels.get(0);
        }
        return null;
    }
}
